;;;=================================================================
;;;
;;; CAT.LSP V2.01
;;;
;;; Copier des attributs
;;;
;;; Copyright (C) Patrick_35
;;;
;;;=================================================================

(defun c:cat(/ att bl doc ent s sel *errcat*)

;=========================================================================
; Gestion des erreurs
;=========================================================================

  (defun *errcat* (msg)
    (or (member (strcase msg) '("FUNCTION CANCELLED" ""QUIT / EXIT ABORT"" "FONCTION ANNULEE" "QUITTER / SORTIR ABANDON"))
      (princ (strcat "\nErreur : " msg))
    )
    (vla-endundomark doc)
    (setq *error* s)
    (princ)
  )

  (vl-load-com)
  (setq s *error*
	*error* *errcat*
	doc (vla-get-activedocument (vlax-get-acad-object))
  )
  (vla-startundomark doc)
  (and	(setq ent (entsel "\nSlectionnez le bloc d'origine : "))
	(setq ent (vlax-ename->vla-object (car ent)))
	(eq (vla-get-objectname ent) "AcDbBlockReference")
	(eq (vla-get-hasattributes ent) :vlax-true)
	(princ "\nSlectionnez les blocs destinataires")
	(ssget (list (cons 0 "insert") (cons 66 1)))
    (progn
      (setq att (vlax-invoke ent 'getattributes))
      (vlax-for bl (setq sel (vla-get-activeselectionset doc))
	(mapcar '(lambda(a b)(vla-put-textstring a (vla-get-textstring b))) (vlax-invoke bl 'getattributes) att)
      )
      (princ (strcat "\n" (itoa (vla-get-count sel)) " bloc(s) modifi(s)."))
      (vla-delete sel)
    )
  )
  (vla-endundomark doc)
  (setq *error* s)
  (princ)
)

(setq nom_lisp "CAT")
(if (/= app nil)
  (if (= (strcase (substr app (1+ (- (strlen app) (strlen nom_lisp))) (strlen nom_lisp))) nom_lisp)
    (princ (strcat "..." nom_lisp " charg."))
    (princ (strcat "\n" nom_lisp ".LSP Charg.....Tapez " nom_lisp " pour l'xecuter.")))
  (princ (strcat "\n" nom_lisp ".LSP Charg......Tapez " nom_lisp " pour l'xecuter.")))
(setq nom_lisp nil)
(princ)
